%function [kontrolni_usek, novy_obr]=metoda_aproximace_krivkou_nebo_plochou(vstup, metoda)
close all;
clear all;
clc

%obr = vstup;
obr = imread('obr_lena.jpg','jpg');

%% nastaveni parametru
smer = 'r'; %l,r,u,d pro zmenu smeru extrapolace obrazku
metoda = 'ext_krivkou'; %ext_krivkou, ext_plochou
n = 1; %stupen polynomu
m = 3; %stupen polynomu ve druhem smeru pro fci. inpaint2d, pro volbu 'ext_plochou'
ppp = 32; %pocet pixelu prodlouzeni - o kolik se obraz roztahne
pocet_pixelu_pro_vypocet = 32; %pocet pixelu pro vypocet polynomu (v pripade aproximace plochou je to strana plochy, plocha je ctvercova)
zobraz_radky = []; %vektor radku, jejichz prubehy chceme zobrazit graficky

%%
velikost = size(obr);

%% prevod na sedotonovy obraz
if length(velikost) == 3    %pokud je obraz barevny, prevede se na YCbCr a dale se pracuje pouze s jasovou slozkou
    [obr] = RGBtoY(obr,velikost);
end

%% vyhodnoceni smeru extrapolace

switch smer
   case 'r'
      disp('Smer extrapolace vpravo.') 
   case 'l'
      disp('Smer extrapolace vlevo.') 
      obr = rot90(obr,2);
   case 'u'
      disp('Smer extrapolace nahoru.') 
      obr = rot90(obr,3);
   case 'd'
      disp('Smer extrapolace dolu.') 
      obr = rot90(obr,1);
   otherwise
      disp('Defaultni extrapolace, smer vpravo.')
end

%% tyto radky odseparuji usek pro budouci kontrolu vysledku
velikost = size(obr); 
kontrolni_usek = obr(1:velikost(1),velikost(2)-ppp+1:velikost(2));
obr = obr(1:velikost(1),1:velikost(2)-ppp);
velikost = size(obr);

%% volba metody - extrapolace pomoci radkoveho vektoru nebo plochy
switch metoda
   case 'ext_krivkou'
      [obr, kontrolovany_usek] = inpaint(obr,velikost,zobraz_radky,n,ppp,pocet_pixelu_pro_vypocet);
   case 'ext_plochou'
      [obr, kontrolovany_usek] = inpaint2d(obr,velikost,zobraz_radky,n,m,ppp,pocet_pixelu_pro_vypocet);
end

%% 
switch smer
   case 'r'   
   case 'l'   
      obr = rot90(obr,2);
   case 'u'
      obr = rot90(obr,1);
   case 'd'
      obr = rot90(obr,3);
   otherwise
end

%% zobrazeni vysledneho obrazu
novy_obr = obr;
ShowImage(uint8(novy_obr),1);

if strcmp(metoda, 'ext_krivkou') == true
    title('Zpracovany obraz - metoda aproximace krivkou');
else
    title('Zpracovany obraz - metoda aproximace plochou');
end
