%function [kontrolni_usek, novy_obr] = metoda_dvojite_aproximace(vstup)
close all;
clear all;
clc;

%obr = vstup;
obr = imread('obr_lena.jpg','jpg');

%% nastaveni parametru
smer = 'r'; %l,r,u,d pro zmenu smeru extrapolace obrazku
ppp = 32; %pocet pixelu prodlouzeni - pocet pixelu doplnovanych na konec obrazu
pocet_pixelu_pro_vypocet = 32; %pocet pixelu pro vypocet polynomu
n1 = 1; % rad pouziteho aproximacniho polynomu NIZSIHO stupne
n2 = 2; % rad pouziteho aproximacniho polynomu VYSSIHO stupne

%%
velikost = size(obr); %velikost uchovava rozmery obrazku

%% vypocet vahovaciho vektoru - pro nizky rad se vaha extrapolovane hodnoty smerem dal od okraje obrazu zvysuje, pro vysoky rad se vaha snizuje
for i = 1 : ppp
vahovaci_vektor_low(i) = (double(1) / double(ppp) * i);
vahovaci_vektor_high(i) = 1 - vahovaci_vektor_low(i);
end

%% prevod na sedotonovy obrazek
if length(velikost) == 3    %pokud je obraz barevny, prevede se na YCbCr a dale se pracuje pouze s jasovou slozkou
    [obr] = RGBtoY(obr,velikost);
end

%% vyhodnoceni smeru extrapolace

switch smer
   case 'r'
      disp('Smer extrapolace vpravo.') 
   case 'l'
      disp('Smer extrapolace vlevo.') 
      obr = rot90(obr,2);
   case 'u'
      disp('Smer extrapolace nahoru.') 
      obr = rot90(obr,3);
   case 'd'
      disp('Smer extrapolace dolu.') 
      obr = rot90(obr,1);
   otherwise
      disp('Defaultni extrapolace, smer vpravo.')
end
velikost = size(obr); %velikost uchovava rozmery obrazku

%% tyto radky odseparuji usek pro budouci kontrolu vysledku
kontrolni_usek = obr(1:velikost(1),velikost(2)-(ppp)+1:velikost(2)); %kontrolni_usek uchovava puvodni data pro kontrolu vuci extrapolovanym
obr = obr(1:velikost(1),1:velikost(2)-ppp); %obrazek je zmensen o kontrolni usek
velikost = size(obr); %zmena vektoru 'velikost' pri zmene velikosti obrazu

%% 
[novy_obr1] = extrapolace(obr, velikost,n1,pocet_pixelu_pro_vypocet,ppp); %volani funkce pro extrapolaci polynomem radu n1
[novy_obr2] = extrapolace(obr, velikost,n2,pocet_pixelu_pro_vypocet,ppp); %volani funkce pro extrapolaci polynomem radu n2
velikost = size(novy_obr1); %zmena vektoru 'velikost' pri zmene velikosti obrazu
usek_1 = novy_obr1(1:velikost(1),velikost(2)-ppp+1:velikost(2)); 
usek_2 = novy_obr2(1:velikost(1),velikost(2)-ppp+1:velikost(2));

for radek = 1 : velikost(1)
    for sloupec = 1 : ppp
        usek_1(radek, sloupec) = usek_1(radek, sloupec) * vahovaci_vektor_low(1,sloupec);
        usek_2(radek, sloupec) = usek_2(radek, sloupec) * vahovaci_vektor_high(1,sloupec);
        usek(radek, sloupec) = usek_1(radek, sloupec) + usek_2(radek, sloupec);
    end
end

novy_obr(1:velikost(1),1:velikost(2)-ppp) = obr;
novy_obr(1:velikost(1),velikost(2)-ppp+1:velikost(2)) = usek; %extrapolovany usek obrazu vypocteny vahovanim extrapolace nizkeho a vysokeho radu

%% 
switch smer
   case 'r'   
   case 'l'   
      novy_obr = rot90(novy_obr,2);
   case 'u'
      novy_obr = rot90(novy_obr,1);
   case 'd'
      novy_obr = rot90(novy_obr,3);
   otherwise
end

%% zobrazeni vysledneho obrazu
ShowImage(uint8(novy_obr),1);
title('Zpracovany obraz - metoda dvojite aproximace');
