%function [kontrolni_usek, novy_obr] = metoda_omp(vstup)
clear all
close all
clc

%% vstupni data
%im = vstup;
im = imread('obr_lena.jpg');
smer = 'r'; %l,r,u,d pro zmenu smeru extrapolace obrazku
ppp = 32; %pocet pixelu, o kolik se bude prodluzovat obrazek

%% 
velikost = size(im);

%% prevod na sedotonovy obrazek
if length(velikost) == 3    %pokud je obraz barevny, prevede se na YCbCr a dale se pracuje pouze s jasovou slozkou
    [im] = RGBtoY(im,velikost);
end

%% vyhodnoceni smeru extrapolace

switch smer
   case 'r'
      disp('Smer extrapolace vpravo.')
      im = rot90(im,3);
   case 'd'
      disp('Smer extrapolace dolu.') 
   case 'u'
      disp('Smer extrapolace nahoru.') 
      im = rot90(im,2);
   case 'l'
      disp('Smer extrapolace vlevo.') 
      im = rot90(im,1);
   otherwise
      disp('Defaultni extrapolace, smer vpravo.')
end

%% tyto radky odseparuji usek pro budouci kontrolu vysledku
velikost = size(im);
kontrolni_usek = im(velikost(1)-(ppp)+1:velikost(1),1:velikost(2)); %kontrolni_usek uchovava puvodni data pro kontrolu vuci extrapolovanym

%%
for vyber = 1 : velikost(2); %prochazi postupne sloupce obrazu
signal = double(im(:,vyber)); %jeden sloupec obrazu
% signal = [zeros(n,1); signal];
n = length(signal);

reliable = true(n,1); % vzorky ktere pouzijeme
reliable((end-ppp+1):end) = false; % vzorky, ktere se maji dopocitat

%% predzpracovani
prumer = mean(signal);
signal = signal - prumer;

%% baze DCT
% basis = dctmtx(n)'; %orthonormal DCT basis vectors as columns

%% baze DWT
wavelet = 'db3';
depth = 8;
[Lo_D, Hi_D, Lo_R, Hi_R] = w_filters(wavelet); %wavelet filters
basis = dwtmatrix(Lo_D,Hi_D,depth,signal)'; %DWT basis vectors as columns

%% aplikace masky - "zkraceni"
signal_r = signal(reliable);
basis_r = basis(reliable,:); % vlastne uz to neni baze, ale frame (mene radku nez sloupcu)
rank_of_shortened_basis = rank(basis_r);

%% vypocet koeficientu
OMPparams.StopMaxiter = 55;
OMPparams.StopMaxerror = 10e-5;
OMPparams.NormalizeDict = false;
[coordinates, S] = omp(basis_r,signal_r,OMPparams);

%% rekonstrukce
signal_rec = basis * coordinates;

%% pozpracovani
signal = signal + prumer;
signal_rec = signal_rec + prumer;

im(1:length(signal_r),vyber) = signal(1:length(signal_r),1);
im(length(signal_r)+1:length(signal_rec),vyber) = signal_rec(length(signal_r)+1:length(signal_rec),1);
end

novy_obr = im;
%% 
switch smer
   case 'r' 
      im = rot90(im,1); 
   case 'd'   
   case 'u'
      im = rot90(im,2);
   case 'l'
      im = rot90(im,3);
   otherwise
end

%% zobrazeni vysledneho obrazu

ShowImage(uint8(im),1);
title('Zpracovany obraz - metoda OMP');

%% vykresleni jednoho radku
% time = 1:n;
% plot(time, signal, 'b') % original
% hold on
% plot(time(reliable), signal_rec(reliable), 'g') % interpolace
% plot(time(~reliable), signal_rec(~reliable), 'r') % extrapolace
% % hold off
% axis tight
% 
% figure
% plot(signal-signal_rec)