%function [kontrolni_usek, novy_obr] = metoda_s_detekci_hran(vstup)
close all;
clear all;
clc;

%obr = vstup;
obr = imread('obr_lena.jpg','jpg');

%% nastaveni parametru
smer = 'r'; %l,r,u,d pro zmenu smeru extrapolace obrazku
ppp = 32; %pocet pixelu prodlouzeni - pocet pixelu doplnovanych na konec obrazu
n = 1; % rad pouziteho aproximacniho polynomu
pocet_pixelu_pro_vypocet = 32; %pocet pixelu pro vypocet polynomu

%%
velikost = size(obr); %velikost uchovava rozmery obrazku

%% prevod na sedotonovy obrazek
if length(velikost) == 3    %pokud je obraz barevny, prevede se na YCbCr a dale se pracuje pouze s jasovou slozkou
    [obr] = RGBtoY(obr,velikost);
end

%% vyhodnoceni smeru extrapolace

switch smer
   case 'r'
      disp('Smer extrapolace vpravo.') 
   case 'l'
      disp('Smer extrapolace vlevo.') 
      obr = rot90(obr,2);
   case 'u'
      disp('Smer extrapolace nahoru.') 
      obr = rot90(obr,3);
   case 'd'
      disp('Smer extrapolace dolu.') 
      obr = rot90(obr,1);
   otherwise
      disp('Defaultni extrapolace, smer vpravo.')
end
velikost = size(obr); %velikost uchovava rozmery obrazku

%% tyto radky odseparuji usek pro budouci kontrolu vysledku
kontrolni_usek = obr(1:velikost(1),velikost(2)-(ppp)+1:velikost(2)); %kontrolni_usek uchovava puvodni data pro kontrolu vuci extrapolovanym
obr = obr(1:velikost(1),1:velikost(2)-ppp); %obrazek je zmensen o kontrolni usek
velikost = size(obr); %zmena vektoru 'velikost' pri zmene velikosti obrazu

%% 
indexy_jednicek = zeros(velikost(1),1);
aprox = obr(1:velikost(1),velikost(2)-(pocet_pixelu_pro_vypocet)+1:velikost(2)); 
edge_obr = edge(aprox,'canny');
%filtered = medfilt2(aprox, 'symmetric'); %vyfiltrovani pouziteho useku

for i = 1 : velikost(1)
    if (~isempty(find(edge_obr(i,:) == 1,1,'last')))
        indexy_jednicek(i) = pocet_pixelu_pro_vypocet - find(edge_obr(i,:) == 1,1,'last');
    else
        indexy_jednicek(i) = pocet_pixelu_pro_vypocet;
    end
end

%obr(1:velikost(1),velikost(2)-(pocet_pixelu_pro_vypocet)+1:velikost(2)) = filtered; %obrazu je na puvodni misto prirazen filtrovany(vyhlazeny) usek
edge_obr = uint8(edge_obr*255);
[novy_obr] = extrapolace(obr, velikost,n,indexy_jednicek,ppp); %volani funkce pro extrapolaci
velikost = size(novy_obr); %zmena vektoru 'velikost' pri zmene velikosti obrazu

%novy_obr(1:velikost(1),velikost(2)-(pocet_pixelu_pro_vypocet+ppp)+1:velikost(2)-ppp) = edge_obr; % je mozno zobrazit detekovane hrany

%% 
switch smer
   case 'r'   
   case 'l'   
      novy_obr = rot90(novy_obr,2);
   case 'u'
      novy_obr = rot90(novy_obr,1);
   case 'd'
      novy_obr = rot90(novy_obr,3);
   otherwise
end

%% zobrazeni vysledneho obrazu
novy_obr = uint8(novy_obr);
ShowImage(uint8(novy_obr),1);
title('Zpracovany obraz - metoda s detekci hran');
