%function [kontrolni_usek, novy_obr] = metoda_waveletoveho_rozkladu(vstup)
close all;
clear all;
clc;

%obr = vstup;
obr = imread('obr_lena.jpg','jpg');

%% nastaveni parametru
smer = 'r'; %l,r,u,d pro zmenu smeru extrapolace obrazku
DL = 1; % Decomposition Level (bezne znaceno jako J)
vlnka = 'db1';
ppp = 32; %mocniny 2...pocet pixelu prodlouzeni - pocet pixelu doplnovanych na konec obrazu
ppp = ppp/2;
n = 1; % rad pouziteho aproximacniho polynomu
pocet_pixelu_pro_vypocet = 32; %pocet pixelu pro vypocet polynomu
pocet_pixelu_pro_vypocet = pocet_pixelu_pro_vypocet/2;

%% 
if DL < 6
    
velikost = size(obr); %velikost uchovava rozmery obrazku
%% prevod na sedotonovy obrazek
if length(velikost) == 3    %pokud je obraz barevny, prevede se na YCbCr a dale se pracuje pouze s jasovou slozkou
    [obr] = RGBtoY(obr,velikost);
end
%% vyhodnoceni smeru extrapolace

switch smer
   case 'r'
      disp('Smer extrapolace vpravo.') 
   case 'l'
      disp('Smer extrapolace vlevo.') 
      obr = rot90(obr,2);
   case 'u'
      disp('Smer extrapolace nahoru.') 
      obr = rot90(obr,3);
   case 'd'
      disp('Smer extrapolace dolu.') 
      obr = rot90(obr,1);
   otherwise
      disp('Defaultni extrapolace, smer vpravo.')
end
velikost = size(obr); %velikost uchovava rozmery obrazku

%% tyto radky odseparuji usek pro budouci kontrolu vysledku
kontrolni_usek = obr(1:velikost(1),velikost(2)-(ppp*2)+1:velikost(2)); %kontrolni_usek uchovava puvodni data pro kontrolu vuci extrapolovanym
obr = obr(1:velikost(1),1:velikost(2)-(ppp*2)); 

%% algoritmus waveletove dekompozice
[C,S] = wavedec2(obr,DL,vlnka);         

maxC = max(C);  %maximalni hodnota v matici koeficientu, slouzi pro scalovani do rozsahu 0...255

[obrAC] = RowToImageAC(C,S);
[obrAC] = extrapolace(obrAC,size(obrAC),n,pocet_pixelu_pro_vypocet/(2^(DL-1)),ppp/(2^(DL-1)));%,zobraz_radky);

velikost_S = size(S); %nova rozmerova matice S1
S1 = S;
for i = 1 : velikost_S(1)-1
S1(i+1,2) = S(i+1,2) + ppp/(2^(DL-i));
end
S1(1,2) = S1(2,2);

[C1] = ImageToRowAC(S1,maxC, obrAC); 
    
for i = 1 : DL %od 1 do stupne rozkladu
    switch i
        case 1
            obrtab1 = zeros(S(i+1,1), S(i+1,2)*3); %matice nul o rozmeru 3 krat puvodni velikost obrazku, horizontalne za sebou
            obrtab1pom = zeros(S1(i+1,1),S1(i+1,2)*3); %matice nul o rozmeru 3 krat zvetsena velikost obrazku, horizontalne za sebou
                        
            [obrtab1(1:S(i+1,1),1:S(i+1,2)),obrtab1(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),obrtab1(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3)] = RowToImage(C,S,i,maxC); %zkopirovani dat z radkove matice do obrazove,(puvodni rozmer) vraci hodnoty koeficientu rozsahove prizpusobene pro zobrazeni 0...255
            velikost = size(obrtab1); %vydeleni poctu sloupcu v obrazku tremi (jsou tri za sebou a dale se s nimi pracuje jednotlive)
            velikost(2) = velikost(2)/3;
            [obrtab1pom(1:S1(i+1,1),1:S1(i+1,2))] = extrapolace(obrtab1(1:S(i+1,1),1:S(i+1,2)),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice H (zvetsena velikost)
            [obrtab1pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2)] = extrapolace(obrtab1(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice V (zvetsena velikost)
            [obrtab1pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)] = extrapolace(obrtab1(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice D (zvetsena velikost)
                        
            %ShowImage(uint8(obrtab1pom),1); %zobrazeni obrazku i s extrapolovanymi castmi
            %title('Velikost obrazu 1:H,V,D');
            
            [pom1] = ImageToRow(S1,i,maxC, obrtab1pom(1:S1(i+1,1),1:S1(i+1,2)), obrtab1pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2), obrtab1pom(1:S1(i+1,1),S1(i+1,2)*2+1:S1(i+1,2)*3)); %zkopirovani dat z obrazove matice zpet do radkove matice 'pom'
            C1 = cat(2,C1,pom1); %append matice 'pom' za matici 'C1' 
              
        case 2
            obrtab2 = zeros(S(i+1,1), S(i+1,2)*3); %matice nul o rozmeru 3 krat puvodni velikost obrazku, horizontalne za sebou
            obrtab2pom = zeros(S1(i+1,1),S1(i+1,2)*3); %matice nul o rozmeru 3 krat zvetsena velikost obrazku, horizontalne za sebou
            
            [obrtab2(1:S(i+1,1),1:S(i+1,2)),obrtab2(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),obrtab2(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3)] = RowToImage(C,S,i,maxC); %zkopirovani dat z radkove matice do obrazove,(puvodni rozmer) vraci hodnoty koeficientu rozsahove prizpusobene pro zobrazeni 0...255
            velikost = size(obrtab2); %vydeleni poctu sloupcu v obrazku tremi (jsou tri za sebou a dale se s nimi pracuje jednotlive)
            velikost(2) = velikost(2)/3;
            [obrtab2pom(1:S1(i+1,1),1:S1(i+1,2))] = extrapolace(obrtab2(1:S(i+1,1),1:S(i+1,2)),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice H (zvetsena velikost)
            [obrtab2pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2)] = extrapolace(obrtab2(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice V (zvetsena velikost)
            [obrtab2pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)] = extrapolace(obrtab2(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice D (zvetsena velikost)
                        
            %ShowImage(uint8(obrtab2pom),2); %zobrazeni obrazku i s extrapolovanymi castmi
            %title('Velikost obrazu 2:H,V,D');
            
            [pom2] = ImageToRow(S1,i,maxC, obrtab2pom(1:S1(i+1,1),1:S1(i+1,2)), obrtab2pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2), obrtab2pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)); %zkopirovani dat z obrazove matice zpet do radkove matice 'pom'
            C1 = cat(2,C1,pom2); %append matice 'pom' za matici 'C1'           
            
        case 3
            obrtab3 = zeros(S(i+1,1), S(i+1,2)*3); %matice nul o rozmeru 3 krat puvodni velikost obrazku, horizontalne za sebou
            obrtab3pom = zeros(S1(i+1,1),S1(i+1,2)*3); %matice nul o rozmeru 3 krat zvetsena velikost obrazku, horizontalne za sebou
            
            [obrtab3(1:S(i+1,1),1:S(i+1,2)),obrtab3(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),obrtab3(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3)] = RowToImage(C,S,i,maxC); %zkopirovani dat z radkove matice do obrazove,(puvodni rozmer) vraci hodnoty koeficientu rozsahove prizpusobene pro zobrazeni 0...255
            velikost = size(obrtab3); %vydeleni poctu sloupcu v obrazku tremi (jsou tri za sebou a dale se s nimi pracuje jednotlive)
            velikost(2) = velikost(2)/3;
            [obrtab3pom(1:S1(i+1,1),1:S1(i+1,2))] = extrapolace(obrtab3(1:S(i+1,1),1:S(i+1,2)),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice H (zvetsena velikost)
            [obrtab3pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2)] = extrapolace(obrtab3(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice V (zvetsena velikost)
            [obrtab3pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)] = extrapolace(obrtab3(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice D (zvetsena velikost)
                        
            %ShowImage(uint8(obrtab3pom),3); %zobrazeni obrazku i s extrapolovanymi castmi
            %title('Velikost obrazu 3:H,V,D');
            
            [pom3] = ImageToRow(S1,i,maxC, obrtab3pom(1:S1(i+1,1),1:S1(i+1,2)), obrtab3pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2), obrtab3pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)); %zkopirovani dat z obrazove matice zpet do radkove matice 'pom'
            C1 = cat(2,C1,pom3); %append matice 'pom' za matici 'C1'          
            
        case 4
            obrtab4 = zeros(S(i+1,1), S(i+1,2)*3); %matice nul o rozmeru 3 krat puvodni velikost obrazku, horizontalne za sebou
            obrtab4pom = zeros(S1(i+1,1),S1(i+1,2)*3); %matice nul o rozmeru 3 krat zvetsena velikost obrazku, horizontalne za sebou
            
            [obrtab4(1:S(i+1,1),1:S(i+1,2)),obrtab4(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),obrtab4(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3)] = RowToImage(C,S,i,maxC); %zkopirovani dat z radkove matice do obrazove,(puvodni rozmer) vraci hodnoty koeficientu rozsahove prizpusobene pro zobrazeni 0...255
            velikost = size(obrtab4); %vydeleni poctu sloupcu v obrazku tremi (jsou tri za sebou a dale se s nimi pracuje jednotlive)
            velikost(2) = velikost(2)/3;
            [obrtab4pom(1:S1(i+1,1),1:S1(i+1,2))] = extrapolace(obrtab4(1:S(i+1,1),1:S(i+1,2)),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice H (zvetsena velikost)
            [obrtab4pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2)] = extrapolace(obrtab4(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice V (zvetsena velikost)
            [obrtab4pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)] = extrapolace(obrtab4(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice D (zvetsena velikost)
                       
            %ShowImage(uint8(obrtab4pom),4); %zobrazeni obrazku i s extrapolovanymi castmi
            %title('Velikost obrazu 4:H,V,D');
            
            [pom4] = ImageToRow(S1,i,maxC, obrtab4pom(1:S1(i+1,1),1:S1(i+1,2)), obrtab4pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2), obrtab4pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)); %zkopirovani dat z obrazove matice zpet do radkove matice 'pom'
            C1 = cat(2,C1,pom4); %append matice 'pom' za matici 'C1' 
            
        case 5
            obrtab5 = zeros(S(i+1,1), S(i+1,2)*3); %matice nul o rozmeru 3 krat puvodni velikost obrazku, horizontalne za sebou
            obrtab5pom = zeros(S1(i+1,1),S1(i+1,2)*3); %matice nul o rozmeru 3 krat zvetsena velikost obrazku, horizontalne za sebou
                      
            [obrtab5(1:S(i+1,1),1:S(i+1,2)),obrtab5(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),obrtab5(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3)] = RowToImage(C,S,i,maxC); %zkopirovani dat z radkove matice do obrazove,(puvodni rozmer) vraci hodnoty koeficientu rozsahove prizpusobene pro zobrazeni 0...255
            velikost = size(obrtab5); %vydeleni poctu sloupcu v obrazku tremi (jsou tri za sebou a dale se s nimi pracuje jednotlive)
            velikost(2) = velikost(2)/3;
            [obrtab5pom(1:S1(i+1,1),1:S1(i+1,2))] = extrapolace(obrtab5(1:S(i+1,1),1:S(i+1,2)),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice H (zvetsena velikost)
            [obrtab5pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2)] = extrapolace(obrtab5(1:S(i+1,1),S(i+1,2)+1:S(i+1,2)*2),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice V (zvetsena velikost)
            [obrtab5pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)] = extrapolace(obrtab5(1:S(i+1,1),2*S(i+1,2)+1:S(i+1,2)*3),velikost,n,pocet_pixelu_pro_vypocet/(2^(DL-i)),ppp/(2^(DL-i))); %extrapolace matice D (zvetsena velikost)
                       
            %ShowImage(uint8(obrtab5pom),5); %zobrazeni obrazku i s extrapolovanymi castmi
            %title('Velikost obrazu 5:H,V,D');
            
            [pom5] = ImageToRow(S1,i,maxC, obrtab5pom(1:S1(i+1,1),1:S1(i+1,2)), obrtab5pom(1:S1(i+1,1),S1(i+1,2)+1:S1(i+1,2)*2), obrtab5pom(1:S1(i+1,1),2*S1(i+1,2)+1:S1(i+1,2)*3)); %zkopirovani dat z obrazove matice zpet do radkove matice 'pom'
            C1 = cat(2,C1,pom5); %append matice 'pom' za matici 'C1' 
    end    
end

zpracovanyobr = waverec2(C1,S1,vlnka);

%% 
switch smer
   case 'r'   
   case 'l'   
      zpracovanyobr = rot90(zpracovanyobr,2);
   case 'u'
      zpracovanyobr = rot90(zpracovanyobr,1);
   case 'd'
      zpracovanyobr = rot90(zpracovanyobr,3);
   otherwise
end
%% zobrazeni vysledneho obrazu
novy_obr = uint8(zpracovanyobr);
ShowImage(uint8(novy_obr),6);
title('Zpracovany obraz - metoda waveletoveho rozkladu');
 
 else
    disp('Stupen rozkladu muze byt maximalne 5')
end %if