function [Anorm, origl2norms]= normalize_dict(A)

% l2-normalizes columns of A
%
% Anorm is the normalized dictionary
% origl2norms is a vector of original l2-norms (keep it if want to de-normalize later)

% 2012 Pavel Rajmic


[m,n] = size(A);
Anorm = zeros(m,n); %memory allocation

origl2norms = sqrt(sum(A.^2)); %l2-norms of columns

for cnt = 1:n  %loop over columns
    Anorm(:,cnt) = A(:,cnt)./origl2norms(cnt); %normalization
end